package dev.shadowsoffire.apotheosis.adventure.client;

import net.minecraft.client.renderer.block.model.ItemTransforms;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.block.model.BakedQuad;
import java.util.List;
import net.minecraft.util.RandomSource;
import net.minecraft.core.Direction;
import net.minecraft.world.level.block.state.BlockState;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.Minecraft;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemItem;
import net.minecraft.world.entity.LivingEntity;
import org.jetbrains.annotations.Nullable;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.world.item.ItemStack;
import net.minecraft.client.resources.model.ModelBakery;
import net.minecraft.client.renderer.block.model.ItemOverrides;
import net.minecraft.client.resources.model.BakedModel;

public class GemModel implements BakedModel
{
    private final BakedModel original;
    private final ItemOverrides overrides;
    
    public GemModel(final BakedModel original, final ModelBakery loader) {
        this.original = original;
        this.overrides = new ItemOverrides() {
            public BakedModel m_173464_(final BakedModel original, final ItemStack stack, @Nullable final ClientLevel world, @Nullable final LivingEntity entity, final int seed) {
                final BakedModel specific = GemModel.this.resolve(original, stack, world, entity, seed);
                return (specific == original) ? specific : specific.m_7343_().m_173464_(specific, stack, world, entity, seed);
            }
        };
    }
    
    public BakedModel resolve(final BakedModel original, final ItemStack stack, @Nullable final ClientLevel world, @Nullable final LivingEntity entity, final int seed) {
        final DynamicHolder<Gem> gem = (DynamicHolder<Gem>)GemItem.getGem(stack);
        if (gem.isBound()) {
            return Minecraft.m_91087_().m_91304_().getModel(new ResourceLocation("apotheosis", "item/gems/" + gem.getId().m_135815_()));
        }
        return original;
    }
    
    public ItemOverrides m_7343_() {
        return this.overrides;
    }
    
    @Deprecated
    public List<BakedQuad> m_213637_(final BlockState pState, final Direction pDirection, final RandomSource pRandom) {
        return this.original.m_213637_(pState, pDirection, pRandom);
    }
    
    public boolean m_7541_() {
        return this.original.m_7541_();
    }
    
    public boolean m_7539_() {
        return this.original.m_7539_();
    }
    
    public boolean m_7547_() {
        return this.original.m_7547_();
    }
    
    public boolean m_7521_() {
        return this.original.m_7521_();
    }
    
    @Deprecated
    public TextureAtlasSprite m_6160_() {
        return this.original.m_6160_();
    }
    
    @Deprecated
    public ItemTransforms m_7442_() {
        return this.original.m_7442_();
    }
}
